<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">  
        <meta content="IE=edge" http-equiv="X-UA-Compatible"> 
        <meta content="width=device-width,initial-scale=1" name="viewport"> 
        <meta content="Aulas de introcução à computação científica." name="description"> 
        <meta content="Markinho" name="author"> 
        
        <title> Laços e Listas </title> 
        
        <link href="./css/bootstrap.min.css" rel="stylesheet">        
        <link href="./css/docs.min.css" rel="stylesheet">
        <link href="./css/carbonads.css" rel="stylesheet">
        <link href="./css/prism.css" rel="stylesheet">
        
        <link href="../imagens/favicon.ico" rel="icon"> 
        
        <script type="text/x-mathjax-config">
            MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
        </script>
        <script type="text/javascript" async
            src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_CHTML">
        </script>
        
    </head>
    <body>
        
        <!-- Cabeçalho -->
        <div class="v4-tease">
            <a href="http://www.estruturas.ufpr.br">
                <img style="position: absolute; top: 0; left: 0; border: 0;" 
                     src="../imagens/estruturasUFPR.png" alt="Voltar para Estruturas.UFPR">
            </a>
            <a class="navbar-brand" style="position: absolute; left: 360px;" href="../index.html">
                Aulas de Introdução a Computação Científica
            </a>
        </div>
         <!-- FINAL Cabeçalho -->
        
        <!-- Menu superior -->
        <header class="bs-docs-nav navbar navbar-static-top" id="top"> 
            <div class="container"> 
                <div class="navbar-header"> 
                    <button aria-controls="bs-navbar"  
                            class="collapsed navbar-toggle" data-target="#bs-navbar" 
                            data-toggle="collapse" type="button"> 
                        <span class="sr-only">Alternar Navegação</span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                    </button>
                </div> 
                <nav class="collapse navbar-collapse" id="bs-navbar"> 
                    <ul class="nav navbar-nav"> 
                        <li class="active"> <a href="lacoslistas.html">Laços e Listas</a> </li>
                        <li><a href="#final">Tarefa</a></li>
                    </ul> 
                    <ul class="nav navbar-nav navbar-right"> 
                        <li class="dropdown" id="accountmenu">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">Demais tópicos abordados<b class="caret"></b></a>
                            <ul class="dropdown-menu">
                                <li><a href="../index.html#___sec0">Programando equações</a></li>
                                <li><a href="../index.html#___sec1">Laços e listas</a></li>
                                <li><a href="../index.html#___sec2">Funções e ramificações</a></li>
                                <li><a href="../index.html#___sec3">Entrada do usuário e manipulação de erros</a></li>
                                <li><a href="../index.html#___sec4">Arranjos e gráficos de curvas</a></li>            
                                <li><a href="../index.html#___sec6">Dicionários e cadeias de caracteres</a></li>
                                <li><a href="../index.html#___sec7">Introdução a Classes</a></li>            
                                <li><a href="../index.html#___sec9">Programação orientada a objeto</a></li>
                                <li><a href="../index.html#___sec10">Números aleatórios e jogos simples</a></li>
                                <li><a href="../index.html#___secA">Sequências e relações de recorrência</a></li>
                                <li><a href="../index.html#___secB">Programação de equações diferenciais</a></li>
                                <li><a href="../index.html#___secC">Gráficos tridimensionais</a></li>
                                <li><a href="../index.html#___secD">Programação em paralelo</a></li>
                                <li><a href="../index.html#___secE">Interfaces gráficas de usuário (GUI)</a></li>
                                <li><a href="../index.html#___secF">Migrando Python para código compilado</a></li> 
                            </ul>
                        </li> 
                    </ul> 
                </nav> 
            </div> 
        </header>
        <!-- FINAL MENU SUPERIOR -->
        
        <!-- Painel Superior -->
        <div class="bs-docs-header" id="content" tabindex="-1"> 
            <div class="container"> 
                <h1>Laços e Listas</h1> 
                <p>Precisa repetir uma declaração? Armazenar dados?<br>
                <font size="2px">Prof. Marco André Argenta / PPGECC / UFPR</font></p>
                <div id="carbonads-container">
                    <div class="carbonad">
                        <div id="azcarbon">
                            <a href="./imagens/programando_equacoes.png" target="_blank">
                                <!-- Imagens em 120 px altura e 300 px largura -->
                                <img src="./imagens/lacoslistas.png" class="carbonad-image carbonad-img">
                            </a>
                        </div>
                    </div>
                </div> 
            </div> 
        </div>
        <!-- FINAL PAINEL SUPERIOR -->
        
        <!-- Parte principal -->
        <div class="container bs-docs-container">
            <div class="row">
                
                <!-- Conteúdo Principal -->
                <div class="col-md-9" role="main">
                    <div class="bs-docs-section"> 
                        <h1 class="page-header" id="inicio">Laços e Listas</h1> 
                        <div class="well">
                            Como tarefas repetitivas em um programa podem ser 
                            automatizadas com o uso de laços. Também serão introduzidos 
                            os objetos listas para o armazenamento e processamento 
                            de coleções de dados com ordem específica. Laços e listas 
                            junto com o tópico anterior, consistem na base fundamental 
                            para o resto do curso.
                        </div>               
                    </div>
                    <div class="bs-docs-section" id="tabelaCF">
                        <h1 class="page-header">Tabelas</h1>

                        <p>Faça uma tabela com graus Celsius e seus correspondentes
                        graus Fahrenheit</p>
                        <pre style="line-height: 125%">                        -20  -4.0
                        -15   5.0
                        -10  14.0
                         -5  23.0
                          0  32.0
                          5  41.0
                         10  50.0
                         15  59.0
                         20  68.0
                         25  77.0
                         30  86.0
                         35  95.0
                         40 104.0</pre>
                        
                        <p>Como um programa escreveria na saída tal tabela?</p>
                        
                    </div>
                    <div class="bs-docs-section" id="tabelas">
                        <h1 class="page-header">Fazendo uma tabela</h1>

                        <h2>A solução simples</h2>
                        
                        <p>Sabemos como fazer uma linha na tabela:</p>
                        <pre><code class="language-python">
C = -20
F = 9.0/5*C + 32
print C, F
                        </code></pre>
                        
                        <p>Podemos, simplesmente, repetir a declaração:</p>
                        <pre><code class="language-python">
C = -20; F = 9.0/5*C + 32; print C, F
C = -10; F = 9.0/5*C + 32; print C, F
...
C = 35; F = 9.0/5*C + 32; print C, F
C = 40; F = 9.0/5*C + 32; print C, F
                        </code></pre>
                        <ul>
                            <li> Muito tedioso de escrever, e fácil de errar.</li>
                            <li> Quando programar se torna tedioso, existe, normalmente
                                uma construção que automatiza a escrita!</li>
                            <li> O computador é muito bom em fazer tarefas
                                repetitivas.</li>
                            <li> Para isso, usamos os <em>laços</em>.</li>
                        </ul>
                                                
                    </div>
                    <div class="bs-docs-section" id="lacoWilhe">
                        <h1 class="page-header">Laço <code>while</code></h1>

                        <p>O laço <code>while</code> torna possível repetir
                        tarefas quase semelhantes.</p>
                        <p>Um laço <code>while</code> repete um conjunto de
                        declarações enquanto uma condicional for verdadeira.</p>
                        <pre><code class="language-python">
while condição:
    - declaração 1 -
    - declaração 2 -
    ...
- primeira declaração após o laço - 
                        </code></pre>
                        <ul>
                            <li> Todas as declarações em um laço devem ser indentadas!</li>                            
                        </ul>                        
                    </div>
                    <div class="bs-docs-section" id="tabelaWhile">
                        <h1 class="page-header">Tabela com o laço <code>while</code></h1>

                        <pre><code class="language-python">
print '------------------' # cabeçalho da tabela
C = -20                    # valor inicial para C
dC = 5                     # incremento de C no laço
while C <= 40:             # cabeçalho do laço com a condicional
    F = (9.0/5)*C + 32     # 1a declaração do laço
    print C, F             # 2a declaração do laço
    C = C + dC             # Última declaração do laço
print '------------------' # linha final da tabela
                        </code></pre>
                                                
                    </div>
                    <div class="bs-docs-section" id="tabelaWhileFluxo">
                        <h1 class="page-header">Fluxo do programa em um laço <code>while</code></h1>
                        
                        <iframe width="950" height="330" frameborder="0"
                                src="http://pythontutor.com/iframe-embed.html#code=C+%3D+-20%0AdC+%3D+5%0Awhile+C+%3C%3D+40%3A%0A++++F+%3D+%289.0%2F5%29%2AC+%2B+32%0A++++print+C%2C+F%0A++++C+%3D+C+%2B+dC&curInstr=0&py=2&cumulative=false">
                        </iframe>
                        
                        <p>Vamos simular o laço <code>while</code> na mão:</p>
                        <ul>
                            <li> Primeiro <code>C</code> é -20, \( -20 \leq 40 \) é verdade,
                                então executamos as declarações do laço.</li>
                            <li> Calculamos <code>F</code>, visualizamos o <code>print</code>, e atualizamos 
                                <code>C</code> para -15.</li>
                            <li> Voltamos para a linha do <code>while</code>, avaliamos \( C\leq 40 \), que 
                                é verdade, então vamos a uma nova rodada do laço.</li>
                            <li> Continuamos assim até que o <code>C</code> seja atualizado para 45.</li>
                            <li> Agora a condição do laço \( 45\leq 40 \) é falsa, e o
                                programa pula para a primeira linha após o laço, e o laço termina.</li>
                        </ul>
                                                
                    </div>
                    <div class="bs-docs-section" id="expressoesCondicionais">
                        <h1 class="page-header">Expressões condicionais são verdadeiras
                        ou falsas</h1>

                        <p>Uma expressão com valor verdadeiro (<code>true</code>)
                            ou falso (<code>false</code>) é chamada de expressão
                        condicional. Exemplos: \( C=40 \), \( C\neq 40 \), \( C\geq 40 \), \( C>40 \), \( C < 40 \).</p>
                        
                        <pre><code class="language-python">
C == 40  # note o duplo ==, C = 40 é uma atribuição!
C != 40
C >= 40
C >  40
C <  40
                        </code></pre>
                        
                        <p>Podemos testar expressões condicionais no shell do
                        Python:</p>
                        
                        <pre><code class="language-python">
>>> C = 41
>>> C != 40
True
>>> C < 40
False
>>> C == 41
True
                        </code></pre>
                                                
                    </div>
                    <div class="bs-docs-section" id="combinandoCondicionais">
                        <h1 class="page-header">Combinando expressões condicionais</h1>

                        <p>Varias condições podem ser combinadas com e/ou 
                            <code>and</code>/<code>or</code>:</p>
                        <pre><code class="language-python">
while condição1 and condição2:
    ...

while condição1 or condição2:
    ...
                        </code></pre>
                        
                        <p>Regra 1: condição1 <code>and</code> condição2 é verdadeira se ambas,
                        condição1 e condição2 forem verdadeiras.</p>
                        <p>Regra 2: condição1 <code>or</code> condição2 é verdadeira se uma
                        for verdadeira, condição1 ou condição2.</p>
                        
                        <pre><code class="language-python">
>>> x = 0;  y = 1.2
>>> x >= 0 and y < 1
False
>>> x >= 0 or y < 1
True
>>> x > 0 or y > 1
True
>>> x > 0 or not y > 1
False
>>> -1 < x <= 0   #  -1 < x e x <= 0
True
>>> not (x > 0 or y > 0)
False
                        </code></pre>
                                                
                    </div>
                    <div class="bs-docs-section" id="listas">
                        <h1 class="page-header">Listas</h1>

                        <p>Listas são objetos para armazenar uma sequência de
                        coisas (objetos).</p>
                        
                        <p>Até então, uma variável era relacionada a um número
                        (ou cadeia de caracteres), mas algumas vezes temos 
                        coleções de números, por exemplo, graus 
                        \( -20, -15, -10, -5, 0, \ldots, 40 \).</p>
                        
                        <p>Solução simples: uma variável para cada valor:</p>
                        
                        <pre><code class="language-python">
C1 = -20
C2 = -15
C3 = -10
...
C13 = 40
                        </code></pre>
                        
                        <p>Solução muito tediosa para muitos valores!</p>
                        
                        <p>Melhor: um conjunto de valores podem ser colecionados
                        em uma lista:</p>
                        
                        <pre><code class="language-python">
C = [-20, -15, -10, -5, 0, 5, 10, 15, 20, 25, 30, 35, 40]
                        </code></pre>
                        
                        <p>Agora temos apenas uma variável, C, armazenando todos os valores.</p>
                                                
                    </div>
                    <div class="bs-docs-section" id="operacoesListas">
                        <h1 class="page-header">Operações em listas: inicialização e indexação</h1>

                        <p>Inicialize com os colchetes e vírgulas entre os objetos Python:</p>
                        
                        <pre><code class="language-python">
                            L1 = [-91, 'a string', 7.2, 0]
                        </code></pre>
                        
                        <p>Os elementos são acessados via um índice:</p> 
                        <pre><code class="language-python">
                            L1[3]
                        </code></pre>
                        <p>(índice = 3).</p>
                        
                        <p>Os índices de listas iniciam em 0: 0, 1, 2, ... <code>len(L1) - 1</code>.</p>
                        
                        <pre><code class="language-python">
>>> lista = [4, 6, -3.5]
>>> print lista[0]
4
>>> print lista[1]
6
>>> print lista[2]
-3.5
>>> len(lista)  # comprimento da lista
3
                        </code></pre>
                                                
                    </div>
                    <div class="bs-docs-section" id="operacoesListas2">
                        <h1 class="page-header">Operações em listas:
                        anexar, estender, inserir, excluir</h1>

                        <p>Através dos comandos <code>append</code>, 
                        <code>extend</code>, <code>insert</code>, 
                        <code>delete</code>, podemos anexar um elemento
                        a mais ao final da lista, extender a lista com
                        outra lista, inserir um novo elemento em determinada
                        posição e apagar um elemento, respectivamente.</p>
                        
                        <pre><code class="language-python">
>>> C = [-10, -5, 0, 5, 10, 15, 20, 25, 30]
>>> C.append(35)   # adiciona um novo elemento 35 ao final
>>> C
[-10, -5, 0, 5, 10, 15, 20, 25, 30, 35]
>>> C = C + [40, 45]     # extende C no final
>>> C
[-10, -5, 0, 5, 10, 15, 20, 25, 30, 35, 40, 45]
>>> C.insert(0, -15)     # insere -15 como índice 0
>>> C
[-15, -10, -5, 0, 5, 10, 15, 20, 25, 30, 35, 40, 45]
>>> del C[2]             # apaga o 3o elemento
>>> C
[-15, -10, 0, 5, 10, 15, 20, 25, 30, 35, 40, 45]
>>> del C[2]             # apaga o que é agora o 3o elemento
>>> C
[-15, -10, 5, 10, 15, 20, 25, 30, 35, 40, 45]
>>> len(C)               # comprimento da lista
11
                        </code></pre>
                                                
                    </div>
                    <div class="bs-docs-section" id="operacoesListas3">
                        <h1 class="page-header">Operações em listas:
                        busca por elementos, índices negativos</h1>

                        <p>Podemos buscar um elemento em uma lista utilizando
                            a classe <code>.index()</code> da lista, descobrir
                            se um elemento está na lista com condicionais e buscar
                            o último elemento com índices negativos.</p>
                        
                        <pre><code class="language-python">
>>> C.index(10)   # índice do primeiro elemento com valor 10
3
>>> 10 in C       # 10 é um elemento de C?
True
>>> C[-1]         # o último elemento da lista
45
>>> C[-2]         # o penúltimo elemento da lista
40
>>> umalista = ['book.tex', 'book.log', 'book.pdf']
>>> texfile, logfile, pdf = algumalist  # atribuição dos valores direto à variáveis
>>> texfile
'book.tex'
>>> logfile
'book.log'
>>> pdf
'book.pdf'
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="lacoLista">
                        <h1 class="page-header">Laço <code>for</code> sobre elementos em uma lista</h1>

                        <p>Podemos usar o laço <code>for</code> para correr sobre
                        os elementos de uma lista:</p>
                        
                        <iframe width="800" height="330" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=graus%20%3D%20%5B0,%2010,%2020,%2040,%20100%5D%0Afor%20C%20in%20graus%3A%0A%09print%20'Graus%20Celsius%3A',%20C%0A%09F%20%3D%209/5.*C%20%2B%2032%0A%09print%20'Fahrenheit%3A',%20F%0Aprint%20'A%20lista%20de%20graus%20tem',%20len%28degrees%29,%20'elementos'&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p>Assim como os laços <code>while</code>, as declarações no laço devem
                        ser indentadas!</p>

                    </div>
                    <div class="bs-docs-section" id="lacoFor">
                        <h1 class="page-header">Simulando um laço <code>for</code>
                        na mão</h1>
                        
                        <pre><code class="language-python">
graus = [0, 10, 20, 40, 100]
for C in graus:
    print C
print 'A lista de graus tem', len(degrees), 'elementos'
                        </code></pre>

                        <p>Simulando na mão:</p>
                        <ul>
                            <li> Primeiro passo: <code>C</code> é 0</li>
                            <li> Segundo passo: <code>C</code> é 10 ...e assim
                                por diante...</li>
                            <li> Terceiro passo: <code>C</code> é 20 ...e assim
                                por diante...</li>
                            <li> Quinto passo: <code>C</code> é 100, 
                                agora o laço terminou e o fluxo do programa
                                pula para a primeira declaração com a mesma
                                indentação da linha <code>for C in graus</code>.</li>
                        </ul>

                    </div>
                    <div class="bs-docs-section" id="tabelaFor">
                        <h1 class="page-header">Fazendo uma tabela com um laço <code>for</code></h1>

                        <p>Tabela de graus Celsius e Fahrenheit:</p>
                        
                        <pre><code class="language-python">
grausC = [-20, -15, -10, -5, 0, 5, 10, 15,
             20, 25, 30, 35, 40]
for C in grausC:
    F = (9.0/5)*C + 32
    print C, F
                        </code></pre>
                        
                        <p>Nota: <code>print C, F</code> retorna uma saída feia.
                        Use a sintaxe do printf para deixar a formatação em 
                        duas colunas:</p>
                        
                        <pre><code class="language-python">
print '%5d %5.1f' % (C, F)
                        </code></pre>
                        
                        <p>Saída:</p>
                        <pre><code class="language-python">
-20  -4.0
-15   5.0
-10  14.0
 -5  23.0
  0  32.0
  ......
 35  95.0
 40 104.0
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="forWhile">
                        <h1 class="page-header">Um <code>for</code> pode
                            ser transformado em um <code>while</code></h1>

                        <p>O laço <code>for</code>:</p>
                        
                        <pre><code class="language-python">
for elemento in lista:
    # processa elemento
                        </code></pre>
                        
                        <p>pode sempre ser transformado em um correspondente
                            laço <code>while</code>:</p>
                        
                        <pre><code class="language-python">
indice = 0
while indice < len(lista):
    elemento = lista[indice]
    # processa elemento
    indice += 1
                        </code></pre>

                        <p><em>Mas nem todo laço <code>while</code> pode ser
                                expressado como um laço <code>for</code>!</em></p>
                        
                    </div>
                    <div class="bs-docs-section" id="forWhileEx">
                        <h1 class="page-header">Versão em <code>while</code>
                        do laço para fazer uma tabela</h1>

                        <pre><code class="language-python">
Cgraus = [-20, -15, -10, -5, 0, 5, 10,
            15, 20, 25, 30, 35, 40]
indice = 0
while indice < len(Cgraus):
    C = Cgraus[indice]
    F = (9.0/5)*C + 32
    print '%5d %5.1f' % (C, F)
    indice += 1
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="lacoSoma">
                        <h1 class="page-header">Implemente uma somatória usando
                        laço</h1>
                        
                        $$ S = \sum_{i=1}^N i^2 $$

                        <pre><code class="language-python">
N = 14

S = 0
for i in range(1, N+1):
    S += i**2
                        </code></pre>
                        <p>Ou (menos comum):</p>
                        <pre><code class="language-python">
S = 0
i = 1
while i <= N:
    S += i**2
    i += 1
                        </code></pre>
                        
                        <p>Somatórios são recorrentes, então lembre-se da
                        implementação!</p>

                    </div>
                    <div class="bs-docs-section" id="armazenandoColunasListas">
                        <h1 class="page-header">Armazenando colunas de tabelas
                        como listas</h1>

                        <p>Vamos colocar todos os valores de Fahrenheit também
                        em uma lista:</p>
                        
                        <iframe width="800" height="330" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=Cgraus%20%3D%20%5B-20,%20-15,%20-10,%20-5,%200,%205,%2010,%2015,%2020,%2025,%2030,%2035,%2040%5D%0AFgraus%20%3D%20%5B%5D%20%20%20%20%20%20%20%20%20%20%20%20%23%20iniciamos%20com%20uma%20lista%20vazia%0Afor%20C%20in%20Cgraus%3A%0A%20%20%20%20F%20%3D%20%289.0/5%29*C%20%2B%2032%0A%20%20%20%20Fgraus.append%28F%29%20%20%20%23%20adicionamos%20um%20novo%20elemento%20a%20Fgraus%0Aprint%20Fgraus&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p><code>print Fgraus</code> resulta em:</p>
                        
                        <pre><code class="language-python">
[-4.0, 5.0, 14.0, 23.0, 32.0, 41.0, 50.0, 59.0, 68.0, 77.0, 86.0, 95.0, 104.0]
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="forListaIndices">
                        <h1 class="page-header">Laço <code>for</code> em
                        índices de listas</h1>

                        <p>Laços <code>for</code> normalmente percorrem os
                        valores em uma lista (os elementos):</p>
                        
                        <pre><code class="language-python">
for elemento in lista:
    # elemento variável no processo
                        </code></pre>
                        
                        <p>Podemos, alternativamente, percorrer os índices da lista:</p>
                        
                        <pre><code class="language-python">
for i in range(0, len(lista), 1):
    elemento = lista[i]
    # processa o elemento ou lista[i] diretamente
                        </code></pre>
                        
                        <div class="panel panel-default">
                            <div class="panel-body">
                                <code>range(start, stop, inc)</code> gera uma lista
                                de inteiros iniciando pelo valor de <code>start</code>,
                                depois <code>start + inc</code>, depois <code>start + 2*inc</code>
                                e assim por diante até um valor antes do valor de <code>stop</code>.<br>
                                <code>range(stop)</code> é um código curto para <code>range(0, stop, 1)</code>.
                            </div>
                        </div>
                        
                        <pre><code class="language-python">
>>> range(3)         # = range(0, 3, 1)
[0, 1, 2]
>>> range(2, 8, 3)
[2, 5]
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="mudarElemLista">
                        <h1 class="page-header">Como podemos mudar elementos
                        em uma lista?</h1>

                        <p>Digamos que queremos adicionar o número 2 a todos 
                        os números em uma lista:</p>
                        
                        <pre><code class="language-python">
>>> v = [-1, 1, 10]
>>> for e in v:
...     e = e + 2
...
>>> v
[-1, 1, 10]   # não alterado!!
                        </code></pre>
                        
                        <iframe width="800" height="330" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=v%20%3D%20%5B-1,%201,%2010%5D%0Afor%20e%20in%20v%3A%0A%20%20%20%20e%20%3D%20e%20%2B%202&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <p>Mas o <code>e</code> não é um elemento da lista?!?</p>

                    </div>
                    <div class="bs-docs-section" id="mudarElemListaIndice">
                        <h1 class="page-header">É preciso um elemento indexado</h1>

                        <p>Mudar um elemento de uma lista requer a atribuição
                        à um elemento indexado.</p>
                        
                        <p>Qual é o problema?</p>
                        
                        <p>Dentro do laço, <code>e</code> é uma simples variável
                            (tipo <code>int</code>), no primeiro passo se torna
                            1, depois 3, depois 12, mas a lista <code>v</code>
                        é inalterada.</p>
                        
                        <p>Solução: é necessário indexar um elemento de uma lista
                        para mudar o seu valor:</p>
                        
                        <pre><code class="language-python">
>>> v = [-1, 1, 10]
>>> v[1] = 4    # atribui 4 para o 2o elemento (índice 1) em v
>>> v
[-1, 4, 10]
>>>
>>> for i in range(len(v)):
...     v[i] = v[i] + 2
...
>>> v
[1, 6, 12]
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="compreensaoLista">
                        <h1 class="page-header">Compreensão da lista</h1>

                        <p>Como criar listas de maneiras compactas?</p>
                        
                        <p>Exemplo: compute duas listas em um laço <code>for</code>.</p>
                        
                        <pre><code class="language-python">
n = 16
Cgraus = [];  Fgraus = []  # listas vazias

for i in range(n):
    Cgraus.append(-5 + i*0.5)
    Fgraus.append((9.0/5)*Cgraus[i] + 32)
                        </code></pre>
                        
                        <p>Python possui um construtor compacto chamado 
                            compreensão da lista, <i>list comprehension</i>, para a geração de 
                            listas a partir de um laço <code>for</code>:</p>
                        
                        <pre><code class="language-python">
Cgraus = [-5 + i*0.5 for i in range(n)]
Fgraus = [(9.0/5)*C + 32 for C in Cgraus]
                        </code></pre>
                        
                        <p>Forma geral de uma compreensão da lista, <i>list comprehension</i>:</p>
                        
                        <pre><code class="language-python">
lista = [expressão for elemento in lista]
                        </code></pre>
                        
                        <p>Sendo que a <code>expressão</code> envolve o <code>elemento</code></p>

                    </div>
                    <div class="bs-docs-section" id="compreensaoListaInterativo">
                        <h1 class="page-header">Demonstração interativa
                        da compreensão da lista</h1>

                        <iframe width="800" height="270" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=n%20%3D%204%0ACgraus%20%3D%20%5B-5%20%2B%20i*2%20for%20i%20in%20range%28n%29%5D%0AFgraus%20%3D%20%5B%289.0/5%29*C%20%2B%2032%20for%20C%20in%20Cgraus%5D&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>

                    </div>
                    <div class="bs-docs-section" id="atravessandoListas">
                        <h1 class="page-header">Atravessando múltiplas listas</h1>

                        <p>Podemos correr um laço sobre duas listas?</p>
                        <p>Solução 1: laço sobre índices</p>
                        
                        <pre><code class="language-python">
for i in range(len(Cgraus)):
    print Cgraus[i], Fgraus[i]
                        </code></pre>
                        
                        <p>Solução 2: usar o construtor <code>zip</code>:</p>
                        
                        <pre><code class="language-python">
for C, F in zip(Cgraus, Fgraus):
    print C, F
                        </code></pre>
                        
                        <p>Exemplo com três listas:</p>
                        
                        <pre><code class="language-python">
>>> l1 = [3, 6, 1];  l2 = [1.5, 1, 0];  l3 = [9.1, 3, 2]
>>> for e1, e2, e3 in zip(l1, l2, l3):
...     print e1, e2, e3
...
3 1.5 9.1
6 1 3
1 0 2
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="listasDeListas">
                        <h1 class="page-header">Listas de listas</h1>

                        <ul>
                            <li>Uma lista pode conter qualquer objeto,
                            inclusive outra lista.</li>
                            <li>Ao invés de se armazenar uma tabela com
                            duas listas separadas, uma para cada coluna,
                            podemos agrupar as duas listas em uma nova:</li>
                        </ul>
                        
                        <pre><code class="language-python">
Cgraus = range(-20, 41, 5)
Fgraus = [(9.0/5)*C + 32 for C in Cgraus]

tabela1 = [Cgraus, Fgraus]  # lista de duas listas

print tabela1[0]     # a lista Cgraus
print tabela1[1]     # a lista Fgraus
print tabela1[1][2]  # o 3o elemento em Fgraus
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="tabelaColunaLinha">
                        <h1 class="page-header">Tabela de colunas X tabela de linhas</h1>

                        <ul>
                            <li>A tabela anterior <code>table = [Cgraus,Fgraus]</code>
                            é uma tabela de duas colunas.</li>
                            <li>Vamos fazer uma tabela de linhas, onde cada linha
                            é um par [C, F]:</li>
                        </ul>
                        
                        <pre><code class="language-python">
tabela2 = []
for C, F in zip(Cgraus, Fgraus):
    linha = [C, F]
    tabela2.append(linha)

# mais compacto com a compreensão de lista:
tabela2 = [[C, F] for C, F in zip(Cgraus, Fgraus)]
print tabela2

[[-20, -4.0], [-15, 5.0], ......., [40, 104.0]]
                        </code></pre>
                        
                        <p>Iteração sobre a lista de listas:</p>
                        
                        <pre><code class="language-python">
for C, F in tabela2:
    # funciona com C e F de uma linha na tabela2

# ou
for linha in tabela2:
    C, F = linha
    ...
                        </code></pre>                        

                    </div>
                    <div class="bs-docs-section" id="tabelaColunasIlust">
                        <h1 class="page-header">Ilustração da tabela de colunas</h1>

                        <img height="500" src="./imagens/tabela1.png" alt="Tabela de Colunas">

                    </div>
                    <div class="bs-docs-section" id="tabelaLinhasIlust">
                        <h1 class="page-header">Ilustração da tabela de linhas</h1>

                        <img height="500" src="./imagens/tabela2.png" alt="Tabela de Colunas">

                    </div>
                    <div class="bs-docs-section" id="extraindoSubListas">
                        <h1 class="page-header">Extraindo sublistas</h1>

                        <p>Podemos facilmente pegar partes de uma lista:</p>
                        
                        <pre><code class="language-python">
>>> A = [2, 3.5, 8, 10]
>>> A[2:]   # do índice 2 ao final da lista
[8, 10]

>>> A[1:3]  # do índice 1 até o índice anterior ao índice 3
[3.5, 8]

>>> A[:3]   # do início até o índice anterior ao índice 3
[2, 3.5, 8]

>>> A[1:-1] # do índice 1 até o elemento final
[3.5, 8]

>>> A[:]    # a lista toda
[2, 3.5, 8, 10]
                        </code></pre> 
                        
                        <div class="alert alert-danger" role="alert">
                            Nota: sublistas (fatias) são cópias da lista original!
                        </div>

                    </div>
                    <div class="bs-docs-section" id="tabelaCopiasMutaveis">
                        <h1 class="page-header">Cópias e Visualizações</h1>

                        <p>Um simples objeto pode ter diversos nomes conectados 
                            a ele, execute os códigos abaixo e preste atenção no 
                            resultado:</p>
                        
                        <pre><code class="language-python">
a = [1, 2, 3]
b = a
a
b
a is b
b[1] = 'oi!'
a
                        </code></pre>
                        
                        <p><code>b</code> é uma visualização de <code>a</code>,
                            então se <code>b</code> muda, <code>a</code> também
                        muda.</p>
                        
                        <p>O conceito chave aqui é mutável x imutável:</p>
                        
                        <ul>
                            <li>Objetos mutáveis podem ser modificados;</li>
                            <li>Objetos imutáveis não podem mais ser modificados 
                                após serem criados.</li>
                        </ul>

                    </div>
                    <div class="bs-docs-section" id="tabelaFazOque">
                        <h1 class="page-header">O que esse pedaço de código faz?</h1>
                        
                        <pre><code class="language-python">
for C, F in tabela2[Cgraus.index(10):Cgraus.index(35)]:
    print '%5.0f %5.1f' % (C, F)
                        </code></pre>
                        
                        <ul>
                            <li>É um laço <code>for</code> sobre uma sublista da tabela2.</li>
                            <li>Índices de sublistas: <code>Cgraus.index(10)</code>,
                                <code>Cgraus.index(35)</code>, ou seja, os índices
                            que correspondem aos elementos 10 e 35.</li>
                        </ul>
                        
                        <p>Saída:</p>
                        
                        <pre><code class="language-python">
10  50.0
15  59.0
20  68.0
25  77.0
30  86.0
                        </code></pre>

                    </div>
                    <div class="bs-docs-section" id="listasDeListasGerais">
                        <h1 class="page-header">Iteração sobre listas de listas de
                        listas...</h1>

                        <p>No caso de listas com muitos índices, como
                            por exemplo: <code>lista[i1][i1][i3]...</code></p>
                        
                        <p>Laços sobre os índices da lista seriam:</p>
                        
                        <pre><code class="language-python">
for i1 in range(len(lista)):
    for i2 in range(len(lista[i1])):
        for i3 in range(len(lista[i1][i2])):
            for i4 in range(len(lista[i1][i2][i3])):
                valor = lista[i1][i2][i3][i4]
                # trbalhando a variável valor
                        </code></pre>
                        
                        <p>Laços sobre sublistas:</p>
                        
                        <pre><code class="language-python">
for sublista1 in lista:
    for sublista2 in lista1:
        for sublista3 in lista2:
            for sublista4 in lista3:
                valor = lista4
                # trbalhando a variável valor
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="iteracaoListaListaEsp">
                        <h1 class="page-header">Iteração sobre uma lista de listas
                        específica</h1>

                        <iframe width="800" height="330" frameborder="0" 
                                src="http://pythontutor.com/iframe-embed.html#code=L%20%3D%20%5B%5B9,%207%5D,%20%5B-1,%205,%206%5D%5D%0Afor%20linha%20in%20L%3A%0A%20%20%20%20for%20coluna%20in%20linha%3A%0A%20%20%20%20%20%20%20%20print%20coluna&codeDivHeight=400&codeDivWidth=350&cumulative=false&curInstr=0&heapPrimitives=false&origin=opt-frontend.js&py=2&rawInputLstJSON=%5B%5D&textReferences=false"> 
                        </iframe>
                        
                        <div class="panel panel-default">
                            <div class="panel-body">
                                Como podemos indexar o elemento de valor 5?
                            </div>
                        </div>

                    </div>
                    <div class="bs-docs-section" id="tuplas">
                        <h1 class="page-header">Tuplas são listas imutáveis</h1>

                        <p>Tuplas são listas que não podem ser alteradas.</p>
                        
                        <pre><code class="language-python">
>>> t = (2, 4, 6, 'temp.pdf')    # definindo uma tupla
>>> t =  2, 4, 6, 'temp.pdf'     # podemos fazer sem o parênteses
>>> t[1] = -1
...
TypeError: object does not support item assignment

>>> t.append(0)
...
AttributeError: 'tuple' object has no attribute 'append'

>>> del t[1]
...
TypeError: object doesn't support item deletion
                        </code></pre>
                        
                        <p>Tuplas podem fazer muito de que listas podem:</p>
                        
                        <pre><code class="language-python">
>>> t = t + (-1.0, -2.0)           # adicionando duas tuplas
>>> t
(2, 4, 6, 'temp.pdf', -1.0, -2.0)
>>> t[1]                           # indexando
4
>>> t[2:]                          # subtupla/fatia
(6, 'temp.pdf', -1.0, -2.0)
>>> 6 in t                         # elemento está na tupla?
True
                        </code></pre>                        

                    </div>
                    <div class="bs-docs-section" id="tuplasMais">
                        <h1 class="page-header">Porque tuplas?</h1>

                        <p>Porque tuplas se as listas tem mais funcionalidades?</p>
                        
                        <ul>
                            <li>Tuplas são constantes e por isso protegidas
                            contra mudanças acidentais;</li>
                            <li>Tuplas são mais rápidas que as listas;</li>
                            <li>Tuplas poder ser utilizadas como chaves
                            em dicionários (listas não, veremos isso mais adiante...).</li>
                        </ul>

                    </div>
                    <div class="bs-docs-section" id="listasFuncionalidades">
                        <h1 class="page-header">Funcionalidades de listas</h1>

                        <table class="table">
                            <thead>
                                <tr>
                                    <th align="center">Construção</th> 
                                    <th align="center">Significado</th> 
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td align="left">   <code>a = [] </code></td> 
                                    <td align="left">   inicializa uma lista vazia</td> 
                                </tr>
                                <tr>
                                    <td align="left">   <code>a = [1, 4.4, 'run.py'] </code>    </td> 
                                    <td align="left">   inicializa a lista </td> 
                                </tr>
                                <tr>
                                    <td align="left">   <code>a.append(elem)</code>             </td> 
                                    <td align="left">   adiciona o objeto <code>elem</code> ao final                       </td> 
                                </tr>
                                <tr>
                                    <td align="left">   <code>a + [1,3]</code>                  </td> 
                                    <td align="left">   adiciona duas listas                                                 </td> 
                                </tr>
                                <tr>
                                    <td align="left">   <code>a.insert(i, e)</code>             </td> 
                                    <td align="left">   insere o elemento <code>e</code> antes do índice <code>i</code>     </td> 
                                </tr>
                                <tr>
                                    <td align="left">   <code>a[3]</code>                       </td> 
                                    <td align="left">   elemento da lista na posição 3                                          </td> </tr>
                                <tr>
                                    <td align="left">   <code>a[-1]</code>                      </td> 
                                    <td align="left">   pega o último elemento da lista                                         </td> </tr>
                                <tr>
                                    <td align="left">   <code>a[1:3]</code>                     </td> 
                                    <td align="left">   corte: copia dos dados para uma sublist (aqui: índices 1, 2)                </td> </tr>
                                <tr>
                                    <td align="left">   <code>del a[3]</code>                   </td> 
                                    <td align="left">   apaga um elemento (índice <code>3</code>)                      </td> </tr>
                                <tr>
                                    <td align="left">   <code>a.remove(e)</code>                </td> 
                                    <td align="left">   remove um elemento com o valor <code>e</code>                   </td> </tr>
                                <tr>
                                    <td align="left">   <code>a.index('run.py')</code>          </td> 
                                    <td align="left">   busca o índice correspondente ao valor do elemento                </td> </tr>
                                <tr>
                                    <td align="left">   <code>'run.py' in a</code>              </td> 
                                    <td align="left">   testa se um valor está na lista                      </td> </tr>
                                <tr>
                                    <td align="left">   <code>a.count(v)</code>                 </td> 
                                    <td align="left">   conta quantos elementos possuem o valor <code>v</code>    </td> </tr>
                                <tr>
                                    <td align="left">   <code>len(a)</code>                     </td> 
                                    <td align="left">   número dos elementos na lista <code>a</code>                     </td> </tr>
                                <tr>
                                    <td align="left">   <code>min(a)</code>                     </td> 
                                    <td align="left">   o menor elemento na lista <code>a</code>                        </td> </tr>
                                <tr>
                                    <td align="left">   <code>max(a)</code>                     </td> 
                                    <td align="left">   o maior elemento na lista <code>a</code>                         </td> </tr>
                                <tr>
                                    <td align="left">   <code>sum(a)</code>                     </td> 
                                    <td align="left">   soma todos os elementos de <code>a</code>                            </td> </tr>
                                <tr>
                                    <td align="left">   <code>sorted(a)</code>                  </td> 
                                    <td align="left">   retorna uma versão ordenada da lista <code>a</code>                  </td> </tr>
                                <tr>
                                    <td align="left">   <code>reversed(a)</code>                </td> 
                                    <td align="left">   retorna uma versão ordenada ao inverso da lista <code>a</code>         </td> </tr>
                                <tr>
                                    <td align="left">   <code>b[3][0][2]</code>                 </td> 
                                    <td align="left">   indexação de listas de listas                                          </td> </tr>
                                <tr>
                                    <td align="left">   <code>isinstance(a, list)</code>        </td> 
                                    <td align="left">   é <code>True</code> se <code>a</code> é uma lista              </td> </tr>
                                <tr>
                                    <td align="left">   <code>type(a) is list</code>            </td> 
                                    <td align="left">   é <code>True</code> se <code>a</code> é uma lista             </td> </tr>
                            </tbody>
                            </table>

                    </div>
                    
                    <div class="bs-docs-section" id="final">
                        <h1 class="page-header">Tarefa</h1>
                        <p>
                            Dados dos números de horas de sol em Oxford, UK, para cada
                            mês desde Janeiro de 1929 até 2009 (cada linha é ano):
                        </p>                        
                        
                        <div class="well">
                            [
                            [43.8, 60.5, 190.2, 144.7, 240.9, 210.3, 219.7, 176.3, 199.1, 109.2, 78.7, 67.0],<br>
                            [49.9, 54.3, 109.7, 102.0, 134.5, 211.2, 174.1, 207.5, 108.2, 113.5, 68.7, 23.3],<br>
                            [63.7, 72.0, 142.3, 93.5, 150.1, 158.7, 127.9, 135.5, 92.3, 102.5, 62.4, 38.5],<br>
                            [51.0, 57.9, 133.4, 110.9, 112.4, 199.3, 124.0, 178.3, 102.1, 100.7, 55.7, 58.0],<br>
                            [69.5, 94.3, 187.6, 152.5, 170.2, 226.9, 237.6, 242.7, 177.3, 101.3, 53.9, 59.0],<br>
                            [65.9, 96.6, 122.5, 124.9, 216.3, 192.7, 269.3, 184.9, 149.1, 81.5, 48.7, 31.3],<br>
                            [48.1, 62.0, 121.5, 127.3, 188.5, 196.3, 274.3, 199.9, 144.7, 102.6, 65.4, 48.9],<br>
                            [43.4, 89.2, 71.4, 133.2, 179.5, 166.2, 119.2, 184.7, 79.3, 103.1, 48.9, 62.3],<br>
                            [50.9, 66.6, 99.7, 103.1, 185.0, 181.3, 140.1, 202.3, 143.0, 79.1, 65.9, 41.2],<br>
                            [41.2, 66.9, 172.3, 180.9, 144.9, 190.6, 133.5, 151.3, 110.9, 118.1, 70.0, 52.4],<br>
                            [46.4, 104.9, 86.2, 171.7, 184.9, 227.9, 139.7, 153.7, 147.0, 94.3, 41.1, 46.0],<br>
                            [83.1, 22.8, 128.3, 118.1, 215.4, 273.4, 165.1, 199.5, 179.5, 95.5, 76.8, 46.5],<br>
                            [41.7, 67.9, 118.7, 106.9, 141.9, 210.3, 227.5, 163.7, 123.7, 120.2, 47.1, 46.9],<br>
                            [45.1, 53.9, 69.4, 202.5, 209.4, 234.0, 150.1, 132.7, 124.5, 84.6, 57.8, 51.0],<br>
                            [54.7, 79.3, 132.9, 166.6, 244.1, 192.9, 196.7, 178.3, 142.5, 84.9, 72.3, 49.5],<br>
                            [41.2, 62.4, 142.7, 147.0, 235.6, 170.3, 97.5, 185.2, 143.8, 102.0, 49.3, 64.1],<br>
                            [51.5, 65.7, 152.6, 209.1, 156.1, 182.4, 159.0, 144.8, 64.9, 111.7, 31.0, 46.6],<br>
                            [49.9, 78.7, 107.2, 203.3, 162.9, 149.8, 197.6, 134.8, 98.5, 79.3, 42.9, 74.7],<br>
                            [59.5, 26.3, 70.9, 150.5, 147.3, 185.9, 144.5, 274.9, 159.9, 107.3, 75.4, 37.9],<br>
                            [45.7, 92.9, 160.2, 205.2, 237.1, 124.2, 174.7, 133.7, 146.4, 93.7, 68.6, 65.4],<br>
                            [51.0, 115.1, 112.5, 182.5, 233.3, 242.1, 262.5, 210.3, 151.1, 125.0, 76.2, 65.4],<br>
                            [40.6, 67.5, 138.8, 163.7, 174.1, 244.5, 174.0, 171.1, 112.7, 96.6, 56.9, 55.3],<br>
                            [48.9, 58.6, 92.6, 200.4, 152.1, 251.9, 216.7, 174.7, 110.8, 105.6, 75.1, 69.8],<br>
                            [94.1, 96.7, 105.0, 178.2, 207.0, 217.6, 194.0, 180.5, 140.3, 105.0, 72.1, 77.7],<br>
                            [42.5, 75.9, 140.7, 183.3, 223.0, 139.7, 203.4, 237.4, 151.7, 84.1, 54.4, 28.4],<br>
                            [75.7, 79.7, 107.9, 202.4, 145.9, 157.1, 157.1, 123.5, 168.8, 94.5, 60.1, 54.5],<br>
                            [40.1, 86.3, 161.4, 173.7, 217.5, 155.3, 268.3, 188.0, 153.1, 119.7, 71.5, 47.3],<br>
                            [50.3, 78.9, 149.7, 158.7, 246.6, 145.0, 168.0, 161.4, 94.3, 116.5, 77.9, 18.2],<br>
                            [50.8, 83.1, 110.2, 168.0, 205.6, 297.1, 157.9, 170.5, 102.6, 92.9, 76.4, 62.3],<br>
                            [54.6, 55.4, 110.7, 145.2, 196.0, 145.7, 188.1, 119.6, 118.0, 93.7, 51.8, 29.5],<br>
                            [85.8, 65.5, 102.0, 153.8, 228.0, 226.3, 272.7, 245.6, 213.9, 144.2, 70.6, 45.0],<br>
                            [37.8, 82.3, 78.0, 164.9, 182.3, 274.9, 129.7, 147.1, 122.8, 60.9, 73.4, 54.5],<br>
                            [43.6, 65.1, 173.2, 86.9, 225.2, 231.2, 196.5, 185.7, 135.8, 118.2, 63.4, 76.5],<br>
                            [70.0, 70.6, 126.3, 143.3, 177.5, 280.3, 137.3, 154.5, 142.3, 108.8, 32.7, 72.6],<br>
                            [58.9, 66.4, 85.8, 119.1, 193.4, 199.4, 188.2, 142.6, 129.7, 78.8, 60.4, 49.8],<br>
                            [37.2, 57.3, 65.9, 128.5, 190.8, 156.1, 214.7, 217.7, 210.4, 134.5, 55.0, 51.1],<br>
                            [83.7, 31.1, 137.7, 141.6, 179.6, 188.7, 122.8, 181.2, 122.9, 109.9, 77.4, 71.9],<br>
                            [42.5, 41.5, 121.5, 81.5, 234.9, 199.0, 149.7, 188.6, 168.0, 90.4, 61.0, 41.7],<br>
                            [64.2, 88.2, 174.6, 130.8, 184.2, 232.0, 234.4, 167.1, 116.5, 95.1, 69.2, 70.6],<br>
                            [50.0, 54.0, 148.5, 184.5, 155.0, 206.6, 136.2, 124.0, 114.9, 66.5, 47.9, 35.9],<br>
                            [40.0, 78.1, 70.5, 221.3, 161.9, 276.9, 243.8, 157.5, 97.4, 112.0, 84.6, 35.6],<br>
                            [34.5, 115.9, 120.8, 132.7, 224.8, 270.9, 192.4, 185.6, 157.3, 106.2, 64.7, 43.8],<br>
                            [42.1, 69.5, 106.0, 122.9, 228.9, 143.5, 259.3, 134.2, 166.5, 135.2, 102.0, 29.8],<br>
                            [41.8, 27.3, 144.0, 117.6, 141.9, 150.4, 168.7, 160.9, 129.1, 91.6, 80.6, 47.6],<br>
                            [38.8, 74.1, 150.7, 167.7, 168.0, 249.5, 171.1, 192.0, 153.9, 95.1, 89.1, 62.9],<br>
                            [56.3, 58.3, 101.7, 142.1, 191.4, 206.2, 187.8, 198.7, 146.5, 105.4, 52.9, 58.8],<br>
                            [44.7, 57.8, 72.7, 131.4, 159.1, 301.0, 242.4, 218.6, 147.0, 120.7, 85.1, 34.4],<br>
                            [70.3, 42.6, 107.8, 148.7, 172.0, 261.4, 254.2, 257.4, 118.2, 43.6, 54.1, 58.6],<br>
                            [35.4, 74.4, 87.2, 157.9, 217.5, 123.2, 193.6, 123.4, 101.8, 107.3, 102.4, 45.2],<br>
                            [53.6, 58.9, 128.1, 113.6, 202.8, 171.7, 146.4, 157.4, 159.3, 87.5, 77.3, 34.3],<br>
                            [72.0, 67.3, 92.9, 126.4, 190.9, 166.6, 192.2, 167.4, 171.0, 117.0, 70.0, 59.7],<br>
                            [84.0, 58.8, 86.7, 165.4, 228.7, 186.7, 168.9, 169.0, 136.4, 111.8, 61.4, 64.4],<br>
                            [50.9, 75.3, 57.8, 110.4, 98.3, 122.8, 129.0, 199.8, 157.3, 101.9, 43.7, 57.5],<br>
                            [55.0, 33.8, 144.7, 164.4, 187.2, 148.4, 151.4, 159.8, 141.0, 66.3, 68.5, 60.4],<br>
                            [54.9, 74.0, 89.5, 150.5, 126.8, 180.3, 257.5, 214.5, 92.4, 119.7, 44.3, 62.9],<br>
                            [86.1, 66.0, 48.8, 236.8, 143.4, 244.3, 249.4, 199.8, 99.6, 88.6, 53.8, 57.6],<br>
                            [51.1, 78.0, 112.4, 138.3, 178.3, 165.0, 216.0, 164.9, 143.3, 100.8, 86.1, 44.2],<br>
                            [76.4, 71.2, 127.3, 139.6, 205.6, 222.7, 201.2, 147.0, 171.6, 119.7, 77.9, 64.8],<br>
                            [68.8, 67.8, 111.6, 158.7, 168.7, 129.3, 179.4, 158.2, 132.3, 109.5, 43.9, 42.9],<br>
                            [47.7, 103.7, 85.2, 132.0, 178.1, 142.3, 138.8, 178.8, 136.9, 120.0, 91.4, 46.7],<br>
                            [68.2, 107.0, 100.9, 133.9, 300.8, 244.4, 280.4, 269.5, 141.6, 90.8, 104.1, 26.5],<br>
                            [58.3, 95.7, 144.1, 234.4, 285.0, 121.1, 268.5, 236.6, 164.7, 124.4, 83.7, 58.8],<br>
                            [66.9, 60.0, 87.2, 156.6, 142.9, 150.0, 217.3, 241.4, 165.4, 79.4, 57.4, 58.4],<br>
                            [46.8, 67.3, 73.3, 139.2, 262.7, 212.2, 164.0, 173.6, 120.2, 101.3, 61.5, 47.2],<br>
                            [38.0, 54.7, 135.0, 111.9, 196.7, 231.4, 190.0, 238.3, 107.7, 120.0, 76.3, 55.0],<br>
                            [87.0, 77.6, 127.6, 177.7, 162.1, 254.9, 248.3, 191.8, 113.1, 137.5, 46.7, 68.2],<br>
                            [61.8, 74.9, 198.7, 190.1, 233.5, 194.4, 247.6, 285.1, 135.3, 139.9, 78.1, 40.9],<br>
                            [29.3, 103.4, 76.4, 148.3, 185.7, 290.7, 256.6, 211.6, 125.3, 130.8, 101.0, 55.5],<br>
                            [51.4, 64.2, 150.2, 189.9, 261.4, 137.1, 231.7, 172.0, 169.7, 153.8, 47.1, 55.7],<br>
                            [64.0, 113.0, 77.5, 105.8, 199.8, 114.0, 157.0, 225.0, 133.8, 94.5, 66.3, 38.1],<br>
                            [51.1, 81.3, 97.4, 147.6, 153.6, 202.1, 235.4, 159.2, 155.2, 144.8, 81.1, 60.9],<br>
                            [82.1, 104.9, 112.6, 143.4, 189.8, 164.6, 161.2, 209.4, 126.1, 83.9, 69.2, 51.9],<br>
                            [83.3, 85.0, 74.1, 148.2, 198.3, 226.8, 206.1, 184.1, 123.0, 100.9, 86.9, 79.2],<br>
                            [44.4, 80.5, 101.1, 210.0, 177.5, 163.3, 178.8, 166.2, 167.1, 104.8, 52.3, 41.3],<br>
                            [87.7, 94.4, 154.8, 169.8, 191.2, 213.6, 192.0, 228.4, 175.3, 134.8, 78.9, 53.6],<br>
                            [62.7, 79.1, 101.5, 150.3, 195.5, 223.6, 169.5, 194.1, 174.4, 102.4, 52.4, 58.3],<br>
                            [65.4, 66.3, 79.3, 136.3, 226.4, 177.6, 192.0, 235.7, 155.4, 92.0, 88.0, 55.7],<br>
                            [54.9, 73.1, 95.5, 152.5, 165.7, 246.2, 303.7, 167.2, 156.5, 109.0, 101.2, 42.7],<br>
                            [79.8, 67.6, 165.4, 210.7, 165.5, 149.0, 195.1, 209.2, 142.6, 102.5, 86.9, 57.2],<br>
                            [62.4, 124.1, 115.2, 161.2, 173.2, 223.8, 198.5, 141.8, 113.5, 132.2, 67.0, 73.5],<br>
                            [69.3, 64.5, 161.4, 168.4, 226.1, 203.3, 212.3, 190.6, 163.7, 109.7, 73.5, 61.5],<br>
                            ]
                        </div>
                        
                        <p>Calcule:</p>
                        <ol>
                            <li>Calcule a média de horas de sol para cada mês desde
                                1929 até 2009;</li>
                            <li>Qual mês teve o melhor tempo de acordo com as médias
                                encontradas?</li>
                            <li>Para cada década, 1930, 1940, ..., 2000, calcule a média 
                                de horas de sol por dia no verão, meses de Dezembro e Janeiro juntos
                                (considere o mês com 31 dias).</li>
                        </ol>

                        <!--SOLUÇÃO DA TAREFA-->
                        <button type="button" class="btn btn-info disabled">Soluções</button>                        
                        <!--<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#tarefa">Solução</button>-->
                        <!--Final solução da tarefa-->                        

                        <div id="tarefa" class="collapse">
                            <h3> Exemplo de solução: </h3>

                            <pre><code class="language-python"># -*- coding: utf-8 -*-
'''
Solução do ítem 1
'''
#definindo todos os dados como uma lista, como exemplo eu não completei todos
dados = [
[43.8, 60.5, 190.2, ...],
[49.9, 54.3, 109.7, ...],
[63.7, 72.0, 142.3, ...],
...
]
media_mensal = [0]*12
for mes in range(1, 13):
    m = mes - 1   #correspondente índice na lista (inicia em 0)
    s = 0           #soma
    n = 2009 - 1929 + 1  #número de anos
    for ano in range(1929, 2010):
        y = ano - 1929  #correspondente índice na lista (inicia em 0)
        s += dados[y][m]
    media_mensal[m] = s/n
nomes_meses = ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun',
               'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dec']
#saída formatada:
for nome, valor in zip(nomes_meses, media_mensal):
    print '%s: %.1f' % (nome, valor)

'''
Solução do ítem 2
'''
max_valor = max(media_mensal)
mes = nomes_meses[media_mensal.index(max_valor)]
print '%s teve o melhor tempo com %.1f horas de sol na média' % \
      (mes, max_valor)

max_valor = -1E+20
for i in range(len(media_mensal)):
    valor = media_mensal[i]
    if valor > max_valor:
        max_valor = valor
        max_i = i  #guarde o indice também
print '%s teve o melhor tempo com %.1f horas de sol na média' % \
      (nomes_meses[max_i], max_valor)

'''
Solução do ítem 3
'''
media_decada = []
for inicio_decada in range(1930, 2010, 10):
    Jan_indice = 0; Dec_indice = 11  #indices
    s = 0
    for ano in range(inicio_decada, inicio_decada+10):
        y = ano - 1929  #índice na lista
        s += dados[y-1][Dec_indice] + dados[y][Jan_indice]
    media_decada.append(s/(20.*31))
for i in range(len(media_decada)):
    print 'Década %d-%d: %.1f' % \
          (1930+i*10, 1939+i*10, media_decada[i])
</code></pre>
                            
                        </div>

                    </div>
                    
                </div>
                <!-- FINAL Conteúdo Principal -->
                
                <!-- Menu lateral -->
                <div class="col-md-3" role="complementary"> 
                    <nav class="bs-docs-sidebar hidden-print hidden-sm hidden-xs affix-top" id="menuLateral"> 
                        <ul class="nav bs-docs-sidenav"> 
                            <li><a href="#inicio">Laços e Listas</a></li>
                        </ul> 
                        <a href="#top" class="back-to-top"> Voltar ao topo </a>                 
                    </nav> 
                </div>
                <!-- FINAL Menu lateral -->
                
            </div>
        </div>
        <!-- FINALParte principal -->
        
        <!-- Rodapé -->
        <footer class="bs-docs-footer"> 
            <div class="container"> 
                <ul class="bs-docs-footer-links"> 
                    <li><a href="http://www.estruturas.ufpr.br" target="_blank">estruturas.UFPR</a></li> 
                    <li><a href="http://www.estruturas.ufpr.br/disciplinas/pos-graduacao/introducao-a-computacao-cientifica-com-python/" target="_blank">Introdução à computação científica</a></li> 
                    <li><a href="https://www.python.org/" target="_blank">Python.org</a></li> 
                    <li><a href="https://www.python.org/dev/peps/pep-0257/" target="_blank">Docstring Conventions</a></li> 
                </ul> 
                <p>
                    Prof. Marco André Argenta
                </p> 
            </div> 
        </footer>
        <!-- FINAL Rodapé -->        
        
        <script src="../adicionais/jquery.min.js"></script>
        <script src="../adicionais/bootstrap.min.js"></script>
        <script src="./js/docs.min.js"></script>
        <script src="./js/prism.js"></script>
    </body>
</html>